default:
  interruptible: true
  retry:
    max: 2
    when:
      - runner_system_failure

image: mcr.microsoft.com/dotnet/sdk:5.0-alpine

variables:
  NAME: AutoHideCompletedLevels

stages:
  - build
  - publish

build:
  stage: build
  script:
    # Download B2 CLI client
    - curl -L -o b2 -z b2 https://github.com/Backblaze/B2_Command_Line_Tool/releases/latest/download/b2-linux
    - chmod u+x b2
    # Download private third-party assemblies
    - mkdir assemblies
    - |
      for file in Assembly-CSharp UnityEngine.UI; do
        ./b2 download-file-by-name dotnet-assemblies third-party/TrainValley2/$file.dll assemblies/$file.dll;
      done
    # Restore NuGet packages
    - dotnet restore --packages .nuget
    # Build
    - dotnet build --no-restore --configuration Release
    # Install zip
    - apk add zip
    # Package
    - mkdir -p BepInEx/plugins
    - mv bin/Release/net46/Dev.Isekai.TrainValley2.AutoHideCompletedLevels.dll BepInEx/plugins/
    - zip -r $NAME.zip BepInEx
  rules:
    - when: on_success
  cache:
    key: $CI_COMMIT_REF_SLUG
    paths:
      - .nuget/
      - obj/
  artifacts:
    paths:
      - $NAME.zip

publish:
  stage: publish
  needs:
    - build
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  variables:
    PACKAGE_URL: $CI_API_V4_URL/projects/$CI_PROJECT_ID/packages/generic/$NAME/$CI_COMMIT_TAG/$NAME-$CI_COMMIT_TAG.zip
  script:
    # Install curl
    - apk add curl
    # Upload package
    - mv $NAME.zip $NAME-$CI_COMMIT_TAG.zip
    - |
      curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file $NAME-$CI_COMMIT_TAG.zip $PACKAGE_URL
  rules:
    - if: $CI_COMMIT_TAG
      when: on_success
    - when: never
  release:
    tag_name: $CI_COMMIT_TAG
    description: ./doc/release-notes/$CI_COMMIT_TAG.md
    assets:
      links:
        - name: $NAME-$CI_COMMIT_TAG.zip
          url: $PACKAGE_URL
